/* TFT_Extension.cpp */

#include "TFT_Extension.h"

extern uint8_t SmallFont[];
extern uint8_t BigFont[];

//========================TOUCH_FUNCTIONS======================
unsigned long B_current_time = 0, C_current_time = 0, T_current_time = 0;
bool B_Touched = false, B_timeout = false;
bool C_Touched = false, C_timeout = false;
bool T_Touched = false, T_timeout = false;
bool ButLOCK = false;
uint8_t Butlocked[Button_Groups] = {0,0,0,0,0};
bool CirLOCK = false;
uint8_t Cirlocked[Button_Groups] = {0,0,0,0,0};
int B_lastx1 =0, B_lasty1 =0, B_lastx2 =0, B_lasty2 =0;
int C_lastcx =0, C_lastcy =0;

bool locked = false;
byte flip = 0;
int rad;
unsigned long T = 0;
//=============================================================
struct Radio {
  char * Text[Button_Groups][Num_Of_Buttons];
  bool TxtEnable[Button_Groups][Num_Of_Buttons];
  bool Font_Size[Button_Groups][Num_Of_Buttons];
  bool Button[Button_Groups][Num_Of_Buttons];
  bool lastButton[Button_Groups][Num_Of_Buttons];
  uint8_t number[Button_Groups];
} Block, Circle;

struct TouchButtons{
  bool Button[Num_Of_Buttons];
  bool lastButton[Num_Of_Buttons];
  bool Fill[Num_Of_Buttons];
  bool Round[Num_Of_Buttons];
}T_Button, T_Circle, L_Button, L_Circle, T_Triangle, L_Triangle;

struct latching{
  bool buttons;
  bool circles;
  bool triangles;
  bool ButLock;
  bool CirLock;
  bool TriLock;
}L[Num_Of_Buttons];

struct{
uint8_t R;
uint8_t G;
uint8_t B;
} RB_Text_color[Num_Of_Buttons][Button_Groups], RCB_Text_color[Num_Of_Buttons][Button_Groups],
  RB_Outer_color[Num_Of_Buttons][Button_Groups], RCB_Outer_color[Num_Of_Buttons][Button_Groups],
  RB_Toggled_color[Num_Of_Buttons][Button_Groups], RCB_Toggled_color[Num_Of_Buttons][Button_Groups],
  RB_Untoggled_color[Num_Of_Buttons][Button_Groups], RCB_Untoggled_color[Num_Of_Buttons][Button_Groups];
  
struct
{
  struct Colors 
  {
    uint8_t R;
    uint8_t G;
    uint8_t B;
  }buttons, latches;
} ButtonColor1[Num_Of_Buttons], ButtonColor2[Num_Of_Buttons], CircleColor1[Num_Of_Buttons],
  CircleColor2[Num_Of_Buttons], TriangleColor1[Num_Of_Buttons], TriangleColor2[Num_Of_Buttons];
  
struct Sliders{
  int lastx1;
  int lasty1;
  int lastx2;
  int lasty2;
  int lastC;
  int Slide;
  boolean locked;
}VSliders[10], HSliders[10];

TFT_Extension::TFT_Extension( UTFT *Disp, UTouch *Touch, bool Orient)
{ 
 _Disp = Disp;
 _Touch = Touch;
 _Orient = Orient;
 DisplaySize(320, 240);
 Setup();
} 

void TFT_Extension::Setup() // initial setup of variables, DO NOT CHANGE!!!
{
  B_current_time = 0, C_current_time = 0, T_current_time = 0;
  B_Touched = false, B_timeout = false;
  C_Touched = false, C_timeout = false;
  T_Touched = false, T_timeout = false;
  ButLOCK = false;
  Butlocked[Button_Groups];
  CirLOCK = false;
  Cirlocked[Button_Groups];
  B_lastx1 =0, B_lasty1 =0, B_lastx2 =0, B_lasty2 =0;
  C_lastcx =0, C_lastcy =0;

  locked = false;
  flip = 0;
  T = 0;
}


// Set the display size if the display is anything other than 320x240 
void TFT_Extension::DisplaySize(int X, int Y) 
{
  DispX = X; // Global variable will be set to X
  DispY = Y; // ------------------------------ Y
}
 
// This tells the compiler how many buttons and groups will be made.
int TFT_Extension::TotalRadioButtons(uint8_t *num, uint8_t group) 
{ 
  TotalRB_Group = group; // Set global variable
  for(int temp = 0; temp < group; temp++) 
  {
    Block.number[temp] = num[temp]; // This stores the number of buttons per group
  }
  return *Block.number; // return a pointer to that array.
}
 
bool TFT_Extension::RadioButton(int x1, int y1, int x2, int y2, uint8_t buttonNumber, uint8_t group)
{
    int strl = strlen(Block.Text[buttonNumber][group]);
    int Xpos = (x2 + x1)/2; // find the center of the button
    int Ypos = (y2 + y1)/2; // -----------------------------
	
	if (x1>x2) // This makes sure the coordinates inputted are not backwards. Must be coords of top left and bottom right.  
	  swap(int, x1, x2);

	if (y1>y2) // same with this, top left and bottom right
	  swap(int, y1, y2);


	if(Butlocked[group] != Block.number[group] && !ButLOCK) // This makes allows the buttons to be made until locked out
	{
		_Disp->setColor(RB_Outer_color[buttonNumber][group].R ,RB_Outer_color[buttonNumber][group].G ,RB_Outer_color[buttonNumber][group].B); //Set the outer color of the button.
	   
		_Disp->fillRoundRect(x1, y1, x2, y2); // make the outer part of the button
	   if(Block.Button[group][Butlocked[group]] == true) // This draws the state of the buttons if the screen is cleared and re-entered.
	   {
		  _Disp->setColor(RB_Toggled_color[buttonNumber][group].R ,RB_Toggled_color[buttonNumber][group].G ,RB_Toggled_color[buttonNumber][group].B);//green
		   
		  _Disp->fillRoundRect(B_lastx1 + 4, B_lasty1 + 4, B_lastx2 - 4, B_lasty2 - 4); // This create the toggled button from the same coords, but it gives the appearance of a border.
			
		  if(Block.TxtEnable[buttonNumber][group]) // Set the background color for the text, based on the buttons color
			_Disp->setBackColor(RB_Toggled_color[buttonNumber][group].R ,RB_Toggled_color[buttonNumber][group].G ,RB_Toggled_color[buttonNumber][group].B);
	   }
	   else
	   {
		  _Disp->setColor(RB_Untoggled_color[buttonNumber][group].R ,RB_Untoggled_color[buttonNumber][group].G ,RB_Untoggled_color[buttonNumber][group].B);//red			
		   
		  _Disp->fillRoundRect(x1 + 4, y1 + 4, x2 - 4, y2 - 4);
			
		  if(Block.TxtEnable[buttonNumber][group]) // Set the background color for the text, based on the buttons color
			_Disp->setBackColor(RB_Untoggled_color[buttonNumber][group].R ,RB_Untoggled_color[buttonNumber][group].G ,RB_Untoggled_color[buttonNumber][group].B); 
	   }
	   
	   if(Block.TxtEnable[buttonNumber][group]) // If there is text for that button, show it.
	   {
	     _Disp->setColor(RB_Text_color[buttonNumber][group].R, RB_Text_color[buttonNumber][group].G, RB_Text_color[buttonNumber][group].B); // Show the text color
	     if(Block.Font_Size[buttonNumber][group]) //big font
         {
           _Disp->setFont(BigFont);
           _Disp->print(Block.Text[buttonNumber][group], Xpos - (strl*8), Ypos - 8, 0); //print the string in the center of the button. Big font is 8x8
         }
         else
         {
           _Disp->setFont(SmallFont);
           _Disp->print(Block.Text[buttonNumber][group], Xpos - (strl*4), Ypos - 5, 0); // small font is 4x5
         }
	   }
	   if(Butlocked[group] == Block.number[group]) ButLOCK = true; // if all the buttons have been made, then lockout "if(Butlocked[group] != Block.number[group] && ButLOCK)"
	   else Butlocked[group]++; // otherwise keep making the buttons until all are made.
	}
    
	if( TouchButton(x1,y1,x2,y2) ) // this checks to see if the buttons coords were touched
	{
		for(int cnt = 0; cnt < Block.number[group]; cnt++) // cycle through the buttons in that group
		{ 
		  if(cnt == buttonNumber) // if the cycled button is the requested button, set it true
		  {
			Block.Button[group][cnt] = true;
			B_lastx1 = x1; B_lasty1 = y1; B_lastx2 = x2; B_lasty2 = y2; // record what coords were touched
		  }
		  else 
		  {
			Block.Button[group][cnt] = false; //all other buttons should be false
		  }
		}
	}

	if(Block.Button[group][buttonNumber] != Block.lastButton[group][buttonNumber]) // This makes sure the button cannot be pressed again to repaint the screen.
	{
		if(Block.Button[group][buttonNumber]) // If the button pressed is different, then paint the new button 
		{
		  _Disp->setColor(RB_Toggled_color[buttonNumber][group].R ,RB_Toggled_color[buttonNumber][group].G ,RB_Toggled_color[buttonNumber][group].B);//green
		  _Disp->fillRoundRect(x1 + 4, y1 + 4, x2 - 4, y2 - 4);
		  
		  if(Block.TxtEnable[buttonNumber][group])
		    _Disp->setBackColor(RB_Toggled_color[buttonNumber][group].R ,RB_Toggled_color[buttonNumber][group].G ,RB_Toggled_color[buttonNumber][group].B); // Set the background color for the text, based on the buttons color
		}
	    else // This paints the other buttons to the untoggled color.
		{
		  _Disp->setColor(RB_Untoggled_color[buttonNumber][group].R ,RB_Untoggled_color[buttonNumber][group].G ,RB_Untoggled_color[buttonNumber][group].B);//red
		  _Disp->fillRoundRect(x1 + 4, y1 + 4, x2 - 4, y2 - 4);
		  
		  if(Block.TxtEnable[buttonNumber][group])
		    _Disp->setBackColor(RB_Untoggled_color[buttonNumber][group].R ,RB_Untoggled_color[buttonNumber][group].G ,RB_Untoggled_color[buttonNumber][group].B); // Set the background color for the text, based on the buttons color
		}
		
		if(Block.TxtEnable[buttonNumber][group])
		{
		  _Disp->setColor(RB_Text_color[buttonNumber][group].R, RB_Text_color[buttonNumber][group].G, RB_Text_color[buttonNumber][group].B); // Show text color
          if(Block.Font_Size[buttonNumber][group]) //big font
          {
           _Disp->setFont(BigFont);
           _Disp->print(Block.Text[buttonNumber][group], Xpos - (strl*8), Ypos - 8, 0); //print the string in the center of the button. Big font is 8x8
          }
          else
          {
           _Disp->setFont(SmallFont);
           _Disp->print(Block.Text[buttonNumber][group], Xpos - (strl*4), Ypos - 5, 0); // small font is 4x5
          }
        }		  
	}
  Block.lastButton[group][buttonNumber] = Block.Button[group][buttonNumber]; // record the buttons states
  
  return Block.Button[group][buttonNumber];
}

// See the comments from TotalRadioButtons 
int TFT_Extension::TotalRadioCircleButtons(uint8_t *num, uint8_t group) 
{ 
  TotalRCB_Group = group;
  for(int temp = 0; temp < group; temp++)
  {
    Circle.number[temp] = num[temp];
  }
  return *Circle.number;
}

// See the comments from RadioButton 
bool TFT_Extension::RadioCircleButton(int cx, int cy, int radius, uint8_t buttonNumber, uint8_t group)
{	
    int strl = strlen(Circle.Text[buttonNumber][group]);
	
	if(Cirlocked[group] != Circle.number[group] && !CirLOCK)
	{
		_Disp->setColor(RCB_Outer_color[buttonNumber][group].R ,RCB_Outer_color[buttonNumber][group].G ,RCB_Outer_color[buttonNumber][group].B); // GREY
		_Disp->fillCircle(cx,cy,radius);
		
		if(Circle.Button[group][Cirlocked[group]] == true) 
	    {
	      _Disp->setColor(RCB_Toggled_color[buttonNumber][group].R ,RCB_Toggled_color[buttonNumber][group].G ,RCB_Toggled_color[buttonNumber][group].B);//green
		  _Disp->fillCircle(C_lastcx,C_lastcy,(radius - (radius/4)));
		 
		  if(Circle.TxtEnable[buttonNumber][group]) // Set the background color for the text, based on the buttons color
		    _Disp->setBackColor(RCB_Toggled_color[buttonNumber][group].R ,RCB_Toggled_color[buttonNumber][group].G ,RCB_Toggled_color[buttonNumber][group].B);
	    }
	    else
	    {
		  _Disp->setColor(RCB_Untoggled_color[buttonNumber][group].R ,RCB_Untoggled_color[buttonNumber][group].G ,RCB_Untoggled_color[buttonNumber][group].B);//red
		
		  _Disp->fillCircle(cx,cy,(radius - (radius/4)));
		 
		  if(Circle.TxtEnable[buttonNumber][group]) // Set the background color for the text, based on the buttons color
		    _Disp->setBackColor(RCB_Untoggled_color[buttonNumber][group].R ,RCB_Untoggled_color[buttonNumber][group].G ,RCB_Untoggled_color[buttonNumber][group].B);
	    }
		
		if(Circle.TxtEnable[buttonNumber][group]) // If there is text for that button, show it.
	    {
	       _Disp->setColor(RCB_Text_color[buttonNumber][group].R, RCB_Text_color[buttonNumber][group].G, RCB_Text_color[buttonNumber][group].B);
	       if(Circle.Font_Size[buttonNumber][group]) //big font
           {
             _Disp->setFont(BigFont);
             _Disp->print(Circle.Text[buttonNumber][group], cx - (strl*8), cy - 8, 0); //print the string in the center of the button. Big font is 8x8
           }
           else
           {
             _Disp->setFont(SmallFont);
             _Disp->print(Circle.Text[buttonNumber][group], cx - (strl*4), cy - 5, 0); // small font is 4x5
           }
	    }
		if(Cirlocked[group] == Circle.number[group]) CirLOCK = true;
		else Cirlocked[group]++;
	}

	if(TouchCircle(cx,cy,radius))
	{
		for(int cnt = 0; cnt < Circle.number[group]; cnt++)
		{ 
		  if(cnt == buttonNumber)
          {		  
			Circle.Button[group][cnt] = true;
			C_lastcx = cx; C_lastcy = cy;
		  }
		  else 
			Circle.Button[group][cnt] = false; 
		}
	}

	if(Circle.Button[group][buttonNumber] != Circle.lastButton[group][buttonNumber])
	{
		if(Circle.Button[group][buttonNumber])
		{
		   _Disp->setColor(RCB_Toggled_color[buttonNumber][group].R ,RCB_Toggled_color[buttonNumber][group].G ,RCB_Toggled_color[buttonNumber][group].B);//green
		   _Disp->fillCircle(cx,cy,(radius - (radius/4)));
		   
		   if(Circle.TxtEnable[buttonNumber][group]) // Set the background color for the text, based on the buttons color
		    _Disp->setBackColor(RCB_Toggled_color[buttonNumber][group].R ,RCB_Toggled_color[buttonNumber][group].G ,RCB_Toggled_color[buttonNumber][group].B);
		}
		else 
		{
		   _Disp->setColor(RCB_Untoggled_color[buttonNumber][group].R ,RCB_Untoggled_color[buttonNumber][group].G ,RCB_Untoggled_color[buttonNumber][group].B);//red
		   _Disp->fillCircle(cx,cy,(radius - (radius/4)));
		   
		   if(Circle.TxtEnable[buttonNumber][group]) // Set the background color for the text, based on the buttons color
		    _Disp->setBackColor(RCB_Untoggled_color[buttonNumber][group].R ,RCB_Untoggled_color[buttonNumber][group].G ,RCB_Untoggled_color[buttonNumber][group].B);
		}
		if(Circle.TxtEnable[buttonNumber][group]) // If there is text for that button, show it.
	    {
	       _Disp->setColor(RCB_Text_color[buttonNumber][group].R, RCB_Text_color[buttonNumber][group].G, RCB_Text_color[buttonNumber][group].B);
	       if(Circle.Font_Size[buttonNumber][group]) //big font
           {
             _Disp->setFont(BigFont);
             _Disp->print(Circle.Text[buttonNumber][group], cx - (strl*8), cy - 8, 0); //print the string in the center of the button. Big font is 8x8
           }
           else
           {
             _Disp->setFont(SmallFont);
             _Disp->print(Circle.Text[buttonNumber][group], cx - (strl*4), cy - 5, 0); // small font is 4x5
           }
	    }
	}
	Circle.lastButton[group][buttonNumber] = Circle.Button[group][buttonNumber];
	
	return Circle.Button[group][buttonNumber];
}

// This allows the button to be repainted after switching screens.  
void TFT_Extension::ResetRadioCircleButton(uint8_t group) 
{
 CirLOCK = false; // This sets the lockout variable to be false, indicating it can repaint the buttons
  for(int temp = 0; temp < group; temp++)
  {
    Cirlocked[temp] = false; // Do the same for all the buttons in the group
  }
}

// This allows the button to be repainted after switching screens. 
void TFT_Extension::ResetRadioButton(uint8_t group) 
{
  ButLOCK = false; // This sets the lockout variable to be false, indicating it can repaint the buttons
  for(int temp = 0; temp < group; temp++)
  {
	Butlocked[temp] = false;// Do the same for all the buttons in the group
  }
}

// Standard touch screen button
bool TFT_Extension::TouchButton(int x1, int y1, int x2, int y2, int xc, int yc) 
{
 if((xc & yc) == -1) // This checks to see if you want to use the raw touch data or not, by checking if xc and yc are given values, otherwise it will use the calculated the touch data.
 {
  _Touch->read();
  touchX = _Touch->getX();
  touchY = _Touch->getY();
  xc = (touchX > DispX? 0 : touchX);
  yc = (touchY > DispY? 0 : touchY);
 }  

 if (x1 > x2)
  swap(int ,x1 ,x2);

 if (y1 > y2)
  swap(int ,y1 ,y2);
 
 if(xc >= x1 && xc<= x2 && yc >= y1 && yc <= y2) return true; // If the buttons coords are touched, return true.
 return false; // button coords were not touched, return false.
}

//This is a standard touch screen button and will draw the actual button.
bool TFT_Extension::TouchButton_Draw(int x1, int y1, int x2, int y2, uint8_t buttonNumber, int xc, int yc) 
{
  
 if( TouchButton(x1,y1,x2,y2,xc,yc) ) // sets the button ID to true if touched, otherwise false
   T_Button.Button[buttonNumber] = true;
 else 
   T_Button.Button[buttonNumber] = false;
 
 if(T_Button.Button[buttonNumber] != T_Button.lastButton[buttonNumber]) // allow to only be pressed and not held.
 {
   if(T_Button.Button[buttonNumber]) // if button is touched, show its color. 
      _Disp->setColor(ButtonColor1[buttonNumber].buttons.R, ButtonColor1[buttonNumber].buttons.G, ButtonColor1[buttonNumber].buttons.B);
   else 
      _Disp->setColor(ButtonColor2[buttonNumber].buttons.R, ButtonColor2[buttonNumber].buttons.G, ButtonColor2[buttonNumber].buttons.B);
	  
   if(_Orient == PORTRAIT)
   {
     swap(int, x1,x2);
     swap(int, y1,y2);
   }
   if(T_Button.Fill[buttonNumber]) // tell weather the button is rounded or not and filled or not.
      T_Button.Round[buttonNumber]? _Disp->fillRoundRect(x1,y1,x2,y2) : _Disp->fillRect(x1,y1,x2,y2);
   else 
	  T_Button.Round[buttonNumber]? _Disp->drawRoundRect(x1,y1,x2,y2) : _Disp->drawRect(x1,y1,x2,y2);
 }
 T_Button.lastButton[buttonNumber] = T_Button.Button[buttonNumber]; // This allows the button to be redrawn when released.
 
 return T_Button.Button[buttonNumber];
}

// THIS IS STILL BEING ADDED TO
bool TFT_Extension::TextButton(char *str, bool font_size, int x1, int y1, int x2, int y2, uint8_t R, uint8_t G, uint8_t B)
{
 int strl = strlen(str); // get the length of the string
 int Xpos = (x2 + x1)/2; // find the center of the button
 int Ypos = (y2 + y1)/2; // -----------------------------

 if (x1 > x2)
  swap(int ,x1 ,x2);

 if (y1 > y2)
  swap(int ,y1 ,y2);
  
  _Disp->setColor(R, G, B);
  if(font_size) //big font
  {
    _Disp->setFont(BigFont);
    _Disp->print(str, Xpos - (strl*8), Ypos - 8, 0); //print the string in the center of the button. Big font is 8x8
  }
  else
  {
    _Disp->setFont(SmallFont);
    _Disp->print(str, Xpos - (strl*4), Ypos - 5, 0); // small font is 4x5
  }
 if( TouchButton(x1,y1,x2,y2) ) return true;
 return false;
}
 
bool TFT_Extension ::LatchButton( int x1, int y1, int x2, int y2, uint8_t buttonNumber, int xc, int yc)
{
  if (x1>x2)
	swap(int ,x1 ,x2);

  if (y1>y2)
	swap(int ,y1 ,y2);
	
  if( TouchButton(x1,y1,x2,y2,xc,yc) )
  {
    if(L[buttonNumber].ButLock == true)// If this button is pressed, set the latch. 
	{
      L[buttonNumber].buttons = !L[buttonNumber].buttons;
      L[buttonNumber].ButLock = false; // Only allow it to be pressed once and not held.
    }
  }
  else L[buttonNumber].ButLock = true; // Once released allow it to be pressed again.
  
  return L[buttonNumber].buttons; // Return the buttons state
} 
 
bool TFT_Extension::LatchButton_Draw( int x1, int y1, int x2, int y2, uint8_t buttonNumber, int xc, int yc)
{ 
  
  if (x1>x2)
	swap(int ,x1 ,x2);

  if (y1>y2)
	swap(int ,y1 ,y2);
	
  if( TouchButton(x1,y1,x2,y2,xc,yc) ) // See the comment from TouchButton
  {
    if(L[buttonNumber].ButLock == true)
	{
      L[buttonNumber].buttons = !L[buttonNumber].buttons;
      L[buttonNumber].ButLock = false;
    }
  }
  else L[buttonNumber].ButLock = true;
  
  if(L[buttonNumber].buttons) // This looks to see if the button is latched or not
    L_Button.Button[buttonNumber] = true;
  else 
    L_Button.Button[buttonNumber] = false;
 
  if(L_Button.Button[buttonNumber] != L_Button.lastButton[buttonNumber]) // Allow button to be pressed and not held 
  {
    if(L[buttonNumber].buttons) // Set the color of the button based on the latched state.
       _Disp->setColor(ButtonColor1[buttonNumber].latches.R, ButtonColor1[buttonNumber].latches.G, ButtonColor1[buttonNumber].latches.B);
    else 
       _Disp->setColor(ButtonColor2[buttonNumber].latches.R, ButtonColor2[buttonNumber].latches.G, ButtonColor2[buttonNumber].latches.B);
    if (_Orient == PORTRAIT)
	{
	  swap(int, x1,x2);
	  swap(int, y1,y2);
	}
    if(L_Button.Fill[buttonNumber]) // See if button is told to be rounded or not and filled or not.
       L_Button.Round[buttonNumber]? _Disp->fillRoundRect(x1,y1,x2,y2) : _Disp->fillRect(x1,y1,x2,y2);
    else 
	   L_Button.Round[buttonNumber]? _Disp->drawRoundRect(x1,y1,x2,y2) : _Disp->drawRect(x1,y1,x2,y2);
  }
  L_Button.lastButton[buttonNumber] = L_Button.Button[buttonNumber];
  
  return L[buttonNumber].buttons;
}

// See the comments from TouchButton
bool TFT_Extension ::TouchCircle(int cx, int cy, int radius, int tx, int ty)
{
 if((tx & ty) == -1)
 {
  _Touch->read();
  touchX = _Touch->getX();
  touchY = _Touch->getY();
  tx = (touchX > DispX? 0 : touchX);
  ty = (touchY > DispY? 0 : touchY);
 }
  
 //if (_Orient == PORTRAIT)
  //swap(int ,cx ,cy);
 
  if((pow((cx - tx),2) + pow((cy - ty),2)) <= pow(radius,2)) return true;
  return false;
}

// See the comments from TouchButton_Draw
bool TFT_Extension ::TouchCircle_Draw(int cx, int cy, int radius, uint8_t circleNumber, int tx, int ty)
{
   
  if( TouchCircle(cx,cy,radius,tx,ty) )
    T_Circle.Button[circleNumber] = true;
  else 
    T_Circle.Button[circleNumber] = false;
 
  if(T_Circle.Button[circleNumber] != T_Circle.lastButton[circleNumber])
  {   
    if(T_Circle.Button[circleNumber])
       _Disp->setColor(CircleColor1[circleNumber].buttons.R, CircleColor1[circleNumber].buttons.G, CircleColor1[circleNumber].buttons.B);
    else 
       _Disp->setColor(CircleColor2[circleNumber].buttons.R, CircleColor2[circleNumber].buttons.G, CircleColor2[circleNumber].buttons.B);
    
	//if( _Orient == PORTRAIT)
      //swap(int, cx,cy);
    if(T_Circle.Fill[circleNumber])
       _Disp->fillCircle(cx,cy,radius);
    else 
	   _Disp->drawCircle(cx,cy,radius);
  }
  T_Circle.lastButton[circleNumber] = T_Circle.Button[circleNumber];
 
 return T_Circle.Button[circleNumber];
}

// See the comments from LatchButton
bool TFT_Extension ::LatchCircle(int cx, int cy, int radius, uint8_t circleNumber, int tx, int ty)
{ 
  if(TouchCircle(cx,cy,radius,tx,ty) )
  {
    if(L[circleNumber].CirLock == true) 
	{
      L[circleNumber].circles = !L[circleNumber].circles;
      L[circleNumber].CirLock = false;
    }
  }
  else L[circleNumber].CirLock = true;
  return L[circleNumber].circles;
}

// See the comments from LatchButton_Draw
bool TFT_Extension ::LatchCircle_Draw(int cx, int cy, int radius, uint8_t circleNumber, int tx, int ty)
{ 
  if( TouchCircle(cx,cy,radius,tx,ty) )
  {
    if(L[circleNumber].CirLock == true) 
	{
      L[circleNumber].circles = !L[circleNumber].circles;
      L[circleNumber].CirLock = false;
    }
  }
  else L[circleNumber].CirLock = true;
  
  if(L[circleNumber].circles)
    L_Circle.Button[circleNumber] = true;
  else 
    L_Circle.Button[circleNumber] = false;
 
  if(L_Circle.Button[circleNumber] != L_Circle.lastButton[circleNumber])
  {  
    if(L[circleNumber].circles)
       _Disp->setColor(CircleColor1[circleNumber].latches.R, CircleColor1[circleNumber].latches.G, CircleColor1[circleNumber].latches.B);
    else 
       _Disp->setColor(CircleColor2[circleNumber].latches.R, CircleColor2[circleNumber].latches.G, CircleColor2[circleNumber].latches.B);
    
    if(L_Circle.Fill[circleNumber])
       _Disp->fillCircle(cx,cy,radius);
    else 
	   _Disp->drawCircle(cx,cy,radius);
  }
  L_Circle.lastButton[circleNumber] = L_Circle.Button[circleNumber];
  
  return L[circleNumber].circles;
}

//Calculate the area of an equilateral triangle  
float TFT_Extension ::Area(int Ax, int Ay, int Bx, int By, int Cx, int Cy)
{
 return abs((Ax*(By - Cy) + Bx*(Cy - Ay) + Cx*(Ay - By))/2);
}
 
bool TFT_Extension ::TouchTriangle(int x1,int y1,int base, int deg, int tx, int ty)
{
  if (_Orient == PORTRAIT && ((tx & ty) != -1)) 
    swap(int ,x1 ,y1);
	
  if((tx & ty) == -1)
  {
   _Touch->read();
   touchX = _Touch->getX();
   touchY = _Touch->getY();
   tx = (touchX > DispX? 0 : touchX);
   ty = (touchY > DispY? 0 : touchY);
  }
  
  int rad = base/2; int dir;

  if(deg < 90) dir=up;
  else if(deg < 180) dir=left; // down
  else if(deg < 270) dir=down;
  else dir = right;
  
  Cx = x1 + sin(float(deg) * deg_to_rad) * rad;
  Cy = y1 + cos(float(deg) * deg_to_rad) * rad;
  Cx1 = x1 + sin((float(deg) + 120) * deg_to_rad) * rad;
  Cy1 = y1 + cos((float(deg) + 120) * deg_to_rad) * rad;
  Cx2 = x1 + sin((float(deg) + 240) * deg_to_rad) * rad;
  Cy2 = y1 + cos((float(deg) + 240) * deg_to_rad) * rad;
  
  if(base >= 60) // This also ensures the base is perfectly straight, but for large triangles
  {
    switch(dir)
    {
     case up:
       Cy2-=1;//Cy2-1 
       break;
     case down: 
       Cy2+=1;//Cy2+1
       break;
     case left:
       Cx2-=1;//Cx2-1
       break;
     case right:
       Cx2+=1; //Cx2+1
       break;
    }
  }
  
  float A = Area(Cx, Cy, Cx1, Cy1, Cx2, Cy2); // This is the ideal area of the triangle based on the 3 points.
  float A1 = Area(tx, ty, Cx1, Cy1, Cx2, Cy2);// this checks to see if the touch coords are within the created triangle.
  float A2 = Area(Cx, Cy, tx, ty, Cx2, Cy2);  // The reason three are needed is because each one is a section of the triangle.
  float A3 = Area(Cx, Cy, Cx1, Cy1, tx, ty);

  if(A >= A1 + A2 + A3) return true;
  return false;  
}

// See comments from the other _Draw buttons 
bool TFT_Extension ::TouchTriangle_Draw(int x1,int y1,int base, int deg, uint8_t triangleNumber, int tx, int ty)
{ 
   if( TouchTriangle(x1,y1,base,deg,tx,ty) ) 
    T_Triangle.Button[triangleNumber] = true;
  else 
    T_Triangle.Button[triangleNumber] = false;
 
  if(T_Triangle.Button[triangleNumber] != T_Triangle.lastButton[triangleNumber])
  {
    if(T_Triangle.Button[triangleNumber])
       _Disp->setColor(TriangleColor1[triangleNumber].buttons.R, TriangleColor1[triangleNumber].buttons.G, TriangleColor1[triangleNumber].buttons.B);
    else 
       _Disp->setColor(TriangleColor2[triangleNumber].buttons.R, TriangleColor2[triangleNumber].buttons.G, TriangleColor2[triangleNumber].buttons.B);
	  
    if(T_Triangle.Fill[triangleNumber])
       fillTriangle(x1, y1, base, deg);
    else 
	   drawTriangle(x1, y1, base, deg);
  }
  T_Triangle.lastButton[triangleNumber] = T_Triangle.Button[triangleNumber];
 
 return T_Triangle.Button[triangleNumber]; 
} 
 
// See comments from the other _Draw buttons  
bool TFT_Extension ::LatchTriangle(int x1, int y1, int base, int deg, uint8_t triangleNumber, int tx, int ty)
{
  if( TouchTriangle(x1,y1,base,deg,tx,ty) )
  {
    if(L[triangleNumber].TriLock == true) 
	{
      L[triangleNumber].triangles = !L[triangleNumber].triangles;
      L[triangleNumber].TriLock = false;
    }
  }
  else L[triangleNumber].TriLock = true;
  
  return L[triangleNumber].triangles;
} 
 
// See comments from the other _Draw buttons  
bool TFT_Extension ::LatchTriangle_Draw(int x1, int y1, int base, int deg, uint8_t triangleNumber, int tx, int ty)
{
  if( TouchTriangle(x1,y1,base,deg,tx,ty) )
  {
    if(L[triangleNumber].TriLock == true) 
	{
      L[triangleNumber].triangles = !L[triangleNumber].triangles;
      L[triangleNumber].TriLock = false;
    }
  }
  else L[triangleNumber].TriLock = true;
  
  if(L[triangleNumber].triangles)
    L_Triangle.Button[triangleNumber] = true;
  else 
    L_Triangle.Button[triangleNumber] = false;
 
  if(L_Triangle.Button[triangleNumber] != L_Triangle.lastButton[triangleNumber])
  {
    if(L[triangleNumber].triangles)
       _Disp->setColor(TriangleColor1[triangleNumber].latches.R, TriangleColor1[triangleNumber].latches.G, TriangleColor1[triangleNumber].latches.B);
    else 
       _Disp->setColor(TriangleColor2[triangleNumber].latches.R, TriangleColor2[triangleNumber].latches.G, TriangleColor2[triangleNumber].latches.B);
	  
    if(L_Triangle.Fill[triangleNumber])
       fillTriangle(x1, y1, base, deg);
    else 
	   drawTriangle(x1, y1, base, deg);
  }
  L_Triangle.lastButton[triangleNumber] = L_Triangle.Button[triangleNumber];
  
  return L[triangleNumber].triangles; 
} 
 
bool TFT_Extension::TouchDelayButton(int x1, int y1, int x2, int y2, unsigned long time)
{ 
  B_Touched = false;
  if(TouchButton(x1,y1,x2,y2,-1,-1) && B_timeout == false)
  {
    B_current_time = millis();
    B_timeout = true;
  }
  while(TouchButton(x1,y1,x2,y2,-1,-1) && B_timeout)
  {
    if((millis() - B_current_time) >= time)
    {
      B_Touched = true;
	  break;
    }
  }
  B_timeout = false;
  B_current_time = 0;
  return B_Touched; 
}

bool TFT_Extension::TouchDelayCircle(int x1, int y1, int base, unsigned long time)
{
  C_Touched = false;
  if(TouchCircle(x1,y1,base) && C_timeout == false)
  {
    C_current_time = millis();
    C_timeout = true;
  }
  while(TouchCircle(x1,y1,base) && C_timeout)
  {
    if((millis() - C_current_time) >= time)
    {
      C_Touched = true;
	  break;
    }
  }
  C_timeout = false;
  C_current_time = 0;
  return C_Touched; 
}

bool TFT_Extension::TouchDelayTriangle(int x1, int y1, int base, int deg, unsigned long time)
{ 
  T_Touched = false;
  if(TouchTriangle(x1,y1,base, deg) && T_timeout == false)
  {
    T_current_time = millis();
    T_timeout = true;
  }
  while(TouchTriangle(x1,y1,base, deg) && T_timeout)
  {
    if((millis() - T_current_time) >= time)
    {
      T_Touched = true;
	  break;
    }
  }
  T_timeout = false;
  T_current_time = 0;
  return T_Touched; 
}

uint8_t TFT_Extension::TouchArc(int cx, int cy, int radius, int thickness, int start, int stop)
{
  int XO,YO,XI,YI;
  
  for(float rotate = start; rotate <= stop; rotate++)
  {
    XO= cx + sin((rotate - 90) * deg_to_rad) * float(radius);
    YO= cy + cos((rotate - 90) * deg_to_rad) * float(radius);
    XI= cx + sin((rotate - 90) * deg_to_rad) * float(radius - thickness);
    YI= cy + cos((rotate - 90) * deg_to_rad) * float(radius - thickness);
    if( TouchButton(XI,YI,XO,YO) ) percent = ((rotate/stop) * 100);	
  }
  return percent;
}

uint8_t TFT_Extension::VertSlider(int x1, int y1, int x2, int y2, byte count, byte R, byte G, byte B)
{
  if(!VSliders[count].locked)
  {
    _Disp->setColor(R,G,B);
    _Disp->drawRect(x1, y1, x2, y2);
    _Disp->setColor(BLACK);
    _Disp->fillRect(x1 + 1, y1+1, x2 - 1, y2);
    VSliders[count].lastC = y1+1;
    VSliders[count].locked = true;
  }
  _Touch->read();
  int ty = _Touch->getY(); 
  int YC = ty > DispY? 0 : ty;

  if( TouchButton(x1, y1, x2, y2) )
  {
    if(YC > VSliders[count].lastC)
    {
      _Disp->setColor(BLACK);
      for(VSliders[count].Slide = y1+1; VSliders[count].Slide < (YC-1); VSliders[count].Slide++)
        _Disp->drawLine(x1+1,VSliders[count].Slide, x2-1, VSliders[count].Slide);
      VSliders[count].lastC = YC;
    }
    else
    {
      _Disp->setColor(R,G,B);
      for(VSliders[count].Slide = y2 - 1; VSliders[count].Slide > (VSliders[count].lastC+1); VSliders[count].Slide--)
        _Disp->drawLine(x1+1,VSliders[count].Slide, x2-1, VSliders[count].Slide);
      VSliders[count].lastC = YC;
    } 
  } 
  return map(VSliders[count].Slide, y2, y1, 0 ,100);
}

uint8_t TFT_Extension::HorSlider(int x1, int y1, int x2, int y2, byte count, byte R, byte G, byte B)
{
  if(!HSliders[count].locked)
  {
    _Disp->setColor(R,G,B);
    _Disp->drawRect(x1, y1, x2, y2);
    _Disp->setColor(BLACK);
    _Disp->fillRect(x1 + 1, y1+1, x2 - 1, y2);
    HSliders[count].lastC = x1+1;
    HSliders[count].locked = true;
  }
  _Touch->read();
  int tx = _Touch->getX(); 
  int XC = tx > 320? 0 : tx;

  if(TouchButton(x1, y1, x2, y2))
  {
    if(XC > HSliders[count].lastC)
    {
      _Disp->setColor(BLACK);
      for(HSliders[count].Slide = x1+1; HSliders[count].Slide < (XC-1); HSliders[count].Slide++)
        _Disp->drawLine(HSliders[count].Slide, y1+1,HSliders[count].Slide, y2);
      HSliders[count].lastC = XC;
    }
    else
    {
      _Disp->setColor(R,G,B);
      for(HSliders[count].Slide = x2 - 1; HSliders[count].Slide > (HSliders[count].lastC+1); HSliders[count].Slide--)
        _Disp->drawLine(HSliders[count].Slide, y1+1,HSliders[count].Slide, y2);
      HSliders[count].lastC = XC;
    } 
  } 
  return map(HSliders[count].Slide, x2, x1, 0 ,100);
}
//==================END_OF_TOUCH_FUNCTIONS=======================

//====================DISPLAY_FUNCTIONS==========================

void TFT_Extension::SetTouchButtonColors(uint8_t ButtonNumber, uint8_t Rcolor1, uint8_t Gcolor1, uint8_t Bcolor1,uint8_t Rcolor2, uint8_t Gcolor2, uint8_t Bcolor2, bool fill, bool rounded)
{
  ButtonColor1[ButtonNumber].buttons.R = Rcolor1;
  ButtonColor1[ButtonNumber].buttons.G = Gcolor1;
  ButtonColor1[ButtonNumber].buttons.B = Bcolor1;

  ButtonColor2[ButtonNumber].buttons.R = Rcolor2; 
  ButtonColor2[ButtonNumber].buttons.G = Gcolor2;
  ButtonColor2[ButtonNumber].buttons.B = Bcolor2;
  
  T_Button.lastButton[ButtonNumber] = true;
  T_Button.Fill[ButtonNumber] = fill;
  T_Button.Round[ButtonNumber] = rounded;
}

void TFT_Extension::SetTouchCircleColors(uint8_t ButtonNumber, uint8_t Rcolor1, uint8_t Gcolor1, uint8_t Bcolor1,uint8_t Rcolor2, uint8_t Gcolor2, uint8_t Bcolor2, bool fill)
{
  CircleColor1[ButtonNumber].buttons.R = Rcolor1;
  CircleColor1[ButtonNumber].buttons.G = Gcolor1;
  CircleColor1[ButtonNumber].buttons.B = Bcolor1;

  CircleColor2[ButtonNumber].buttons.R = Rcolor2; 
  CircleColor2[ButtonNumber].buttons.G = Gcolor2;
  CircleColor2[ButtonNumber].buttons.B = Bcolor2;
  
  T_Circle.lastButton[ButtonNumber] = true;
  T_Circle.Fill[ButtonNumber] = fill;
}

void TFT_Extension::SetTouchTriangleColors(uint8_t ButtonNumber, uint8_t Rcolor1, uint8_t Gcolor1, uint8_t Bcolor1,uint8_t Rcolor2, uint8_t Gcolor2, uint8_t Bcolor2, bool fill)
{
  TriangleColor1[ButtonNumber].buttons.R = Rcolor1;
  TriangleColor1[ButtonNumber].buttons.G = Gcolor1;
  TriangleColor1[ButtonNumber].buttons.B = Bcolor1;

  TriangleColor2[ButtonNumber].buttons.R = Rcolor2; 
  TriangleColor2[ButtonNumber].buttons.G = Gcolor2;
  TriangleColor2[ButtonNumber].buttons.B = Bcolor2;
  
  T_Triangle.lastButton[ButtonNumber] = true;
  T_Triangle.Fill[ButtonNumber] = fill;
}

void TFT_Extension::SetLatchButtonColors(uint8_t ButtonNumber, uint8_t Rcolor1, uint8_t Gcolor1, uint8_t Bcolor1,uint8_t Rcolor2, uint8_t Gcolor2, uint8_t Bcolor2, bool fill, bool rounded)
{
  ButtonColor1[ButtonNumber].latches.R = Rcolor1;
  ButtonColor1[ButtonNumber].latches.G = Gcolor1;
  ButtonColor1[ButtonNumber].latches.B = Bcolor1;

  ButtonColor2[ButtonNumber].latches.R = Rcolor2; 
  ButtonColor2[ButtonNumber].latches.G = Gcolor2;
  ButtonColor2[ButtonNumber].latches.B = Bcolor2;
  
  L_Button.lastButton[ButtonNumber] = true;
  L_Button.Fill[ButtonNumber] = fill;
  L_Button.Round[ButtonNumber] = rounded;
}

void TFT_Extension::SetLatchCircleColors(uint8_t ButtonNumber, uint8_t Rcolor1, uint8_t Gcolor1, uint8_t Bcolor1,uint8_t Rcolor2, uint8_t Gcolor2, uint8_t Bcolor2, bool fill)
{
  CircleColor1[ButtonNumber].latches.R = Rcolor1;
  CircleColor1[ButtonNumber].latches.G = Gcolor1;
  CircleColor1[ButtonNumber].latches.B = Bcolor1;

  CircleColor2[ButtonNumber].latches.R = Rcolor2; 
  CircleColor2[ButtonNumber].latches.G = Gcolor2;
  CircleColor2[ButtonNumber].latches.B = Bcolor2;
  
  L_Circle.lastButton[ButtonNumber] = true;
  L_Circle.Fill[ButtonNumber] = fill;
}

void TFT_Extension::SetLatchTriangleColors(uint8_t ButtonNumber, uint8_t Rcolor1, uint8_t Gcolor1, uint8_t Bcolor1,uint8_t Rcolor2, uint8_t Gcolor2, uint8_t Bcolor2, bool fill)
{
  TriangleColor1[ButtonNumber].latches.R = Rcolor1;
  TriangleColor1[ButtonNumber].latches.G = Gcolor1;
  TriangleColor1[ButtonNumber].latches.B = Bcolor1;

  TriangleColor2[ButtonNumber].latches.R = Rcolor2; 
  TriangleColor2[ButtonNumber].latches.G = Gcolor2;
  TriangleColor2[ButtonNumber].latches.B = Bcolor2;
  
  L_Triangle.lastButton[ButtonNumber] = true;
  L_Triangle.Fill[ButtonNumber] = fill;
}

// This function allows text to be entered into the radio button
void TFT_Extension::RB_Text(char * text, bool size, uint8_t ButtonNumber, uint8_t Group, uint8_t Rcolor, uint8_t Gcolor, uint8_t Bcolor)
{
  Block.Text[ButtonNumber][Group] = text;
  Block.Font_Size[ButtonNumber][Group] = size;
  Block.TxtEnable[ButtonNumber][Group] = true;
  
  RB_Text_color[ButtonNumber][Group].R = Rcolor;
  RB_Text_color[ButtonNumber][Group].G = Gcolor;
  RB_Text_color[ButtonNumber][Group].B = Bcolor;
}

// This function allows text to be entered into the radio circle button
void TFT_Extension::RCB_Text(char * text, bool size, uint8_t ButtonNumber, uint8_t Group, uint8_t Rcolor, uint8_t Gcolor, uint8_t Bcolor)
{
  Circle.Text[ButtonNumber][Group] = text;
  Circle.Font_Size[ButtonNumber][Group] = size;
  Circle.TxtEnable[ButtonNumber][Group] = true;
  
  RCB_Text_color[ButtonNumber][Group].R = Rcolor;
  RCB_Text_color[ButtonNumber][Group].G = Gcolor;
  RCB_Text_color[ButtonNumber][Group].B = Bcolor;
}

//The function names tell just what the function does. RB = Radiobutton, RCB = RadioCirclebutton
void TFT_Extension::RB_Outer_Color(uint8_t ButtonNumber, uint8_t Group, uint8_t Rcolor, uint8_t Gcolor, uint8_t Bcolor)
{
  RB_Outer_color[ButtonNumber][Group].R = Rcolor;
  RB_Outer_color[ButtonNumber][Group].G = Gcolor;
  RB_Outer_color[ButtonNumber][Group].B = Bcolor;
}
 
void TFT_Extension::RCB_Outer_Color(uint8_t ButtonNumber, uint8_t Group, uint8_t Rcolor, uint8_t Gcolor, uint8_t Bcolor)
{
  RCB_Outer_color[ButtonNumber][Group].R = Rcolor;
  RCB_Outer_color[ButtonNumber][Group].G = Gcolor;
  RCB_Outer_color[ButtonNumber][Group].B = Bcolor;
}
//======================================================================
 
void TFT_Extension::RB_Toggled_Color(uint8_t ButtonNumber, uint8_t Group, uint8_t Rcolor, uint8_t Gcolor, uint8_t Bcolor)
{
  RB_Toggled_color[ButtonNumber][Group].R = Rcolor;
  RB_Toggled_color[ButtonNumber][Group].G = Gcolor;
  RB_Toggled_color[ButtonNumber][Group].B = Bcolor;
}
 
void TFT_Extension::RCB_Toggled_Color(uint8_t ButtonNumber, uint8_t Group, uint8_t Rcolor, uint8_t Gcolor, uint8_t Bcolor)
{
  RCB_Toggled_color[ButtonNumber][Group].R = Rcolor;
  RCB_Toggled_color[ButtonNumber][Group].G = Gcolor;
  RCB_Toggled_color[ButtonNumber][Group].B = Bcolor;
}
//======================================================================
 
void TFT_Extension::RB_Untoggled_Color(uint8_t ButtonNumber, uint8_t Group, uint8_t Rcolor, uint8_t Gcolor, uint8_t Bcolor)
{
  RB_Untoggled_color[ButtonNumber][Group].R = Rcolor;
  RB_Untoggled_color[ButtonNumber][Group].G = Gcolor;
  RB_Untoggled_color[ButtonNumber][Group].B = Bcolor;
}
 
void TFT_Extension::RCB_Untoggled_Color(uint8_t ButtonNumber, uint8_t Group, uint8_t Rcolor, uint8_t Gcolor, uint8_t Bcolor)
{
  RCB_Untoggled_color[ButtonNumber][Group].R = Rcolor;
  RCB_Untoggled_color[ButtonNumber][Group].G = Gcolor;
  RCB_Untoggled_color[ButtonNumber][Group].B = Bcolor;
}
//======================================================================
//
//======================================================================
void TFT_Extension::RB_Outer_Color_By_Group(uint8_t Group, uint8_t Rcolor, uint8_t Gcolor, uint8_t Bcolor)
{
  for(int temp = 0; temp < Block.number[Group]; temp++)
  {
   RB_Outer_color[temp][Group].R = Rcolor;
   RB_Outer_color[temp][Group].G = Gcolor;
   RB_Outer_color[temp][Group].B = Bcolor;
  }
}
 
void TFT_Extension::RCB_Outer_Color_By_Group(uint8_t Group, uint8_t Rcolor, uint8_t Gcolor, uint8_t Bcolor)
{
  for(int temp = 0; temp < Block.number[Group]; temp++)
  {
   RCB_Outer_color[temp][Group].R = Rcolor;
   RCB_Outer_color[temp][Group].G = Gcolor;
   RCB_Outer_color[temp][Group].B = Bcolor;
  }
}
//======================================================================
 
void TFT_Extension::RB_Toggled_Color_By_Group(uint8_t Group, uint8_t Rcolor, uint8_t Gcolor, uint8_t Bcolor)
{
  for(int temp = 0; temp < Block.number[Group]; temp++)
  {
   RB_Toggled_color[temp][Group].R = Rcolor;
   RB_Toggled_color[temp][Group].G = Gcolor;
   RB_Toggled_color[temp][Group].B = Bcolor;
  }
}
 
void TFT_Extension::RCB_Toggled_Color_By_Group(uint8_t Group, uint8_t Rcolor, uint8_t Gcolor, uint8_t Bcolor)
{
  for(int temp = 0; temp < Block.number[Group]; temp++)
  {
   RCB_Toggled_color[temp][Group].R = Rcolor;
   RCB_Toggled_color[temp][Group].G = Gcolor;
   RCB_Toggled_color[temp][Group].B = Bcolor;
  }
}
//======================================================================
 
void TFT_Extension::RB_Untoggled_Color_By_Group(uint8_t Group, uint8_t Rcolor, uint8_t Gcolor, uint8_t Bcolor)
{
  for(int temp = 0; temp < Block.number[Group]; temp++)
  {
   RB_Untoggled_color[temp][Group].R = Rcolor;
   RB_Untoggled_color[temp][Group].G = Gcolor;
   RB_Untoggled_color[temp][Group].B = Bcolor;
  }
}

void TFT_Extension::RCB_Untoggled_Color_By_Group(uint8_t Group, uint8_t Rcolor, uint8_t Gcolor, uint8_t Bcolor)
{
  for(int temp = 0; temp < Block.number[Group]; temp++)
  {
   RCB_Untoggled_color[temp][Group].R = Rcolor;
   RCB_Untoggled_color[temp][Group].G = Gcolor;
   RCB_Untoggled_color[temp][Group].B = Bcolor;
  }
}
//======================================================================
//
//======================================================================
 
void TFT_Extension::SetAll_RB_Outer_Color( uint8_t Rcolor, uint8_t Gcolor, uint8_t Bcolor)
{
  for( uint8_t G_idx = 0; G_idx < TotalRB_Group; G_idx++)
  {
    for(uint8_t temp = 0; temp < Block.number[G_idx]; temp++)
    {
      RB_Outer_color[temp][G_idx].R = Rcolor;
      RB_Outer_color[temp][G_idx].G = Gcolor;
      RB_Outer_color[temp][G_idx].B = Bcolor;
    }
  }
}
 
void TFT_Extension::SetAll_RCB_Outer_Color( uint8_t Rcolor, uint8_t Gcolor, uint8_t Bcolor)
{
  for( uint8_t G_idx = 0; G_idx < TotalRCB_Group; G_idx++)
  {
    for(uint8_t temp = 0; temp < Block.number[G_idx]; temp++)
    {
      RCB_Outer_color[temp][G_idx].R = Rcolor;
      RCB_Outer_color[temp][G_idx].G = Gcolor;
      RCB_Outer_color[temp][G_idx].B = Bcolor;
    }
  }
}
//===========================================================================
 
void TFT_Extension::SetAll_RB_Toggled_Color( uint8_t Rcolor, uint8_t Gcolor, uint8_t Bcolor)
{
  for( uint8_t G_idx = 0; G_idx < TotalRB_Group; G_idx++)
  {
    for(uint8_t temp = 0; temp < Block.number[G_idx]; temp++)
    {
      RB_Toggled_color[temp][G_idx].R = Rcolor;
      RB_Toggled_color[temp][G_idx].G = Gcolor;
      RB_Toggled_color[temp][G_idx].B = Bcolor;
    }
  }
}
 
void TFT_Extension::SetAll_RCB_Toggled_Color( uint8_t Rcolor, uint8_t Gcolor, uint8_t Bcolor)
{
  for( uint8_t G_idx = 0; G_idx < TotalRCB_Group; G_idx++)
  {
    for(uint8_t temp = 0; temp < Block.number[G_idx]; temp++)
    {
      RCB_Toggled_color[temp][G_idx].R = Rcolor;
      RCB_Toggled_color[temp][G_idx].G = Gcolor;
      RCB_Toggled_color[temp][G_idx].B = Bcolor;
    }
  }
}
//=============================================================================
 
void TFT_Extension::SetAll_RB_Untoggled_Color( uint8_t Rcolor, uint8_t Gcolor, uint8_t Bcolor)
{
  for( uint8_t G_idx = 0; G_idx < TotalRB_Group; G_idx++)
  {
    for(uint8_t temp = 0; temp < Block.number[G_idx]; temp++)
    {
      RB_Untoggled_color[temp][G_idx].R = Rcolor;
      RB_Untoggled_color[temp][G_idx].G = Gcolor;
      RB_Untoggled_color[temp][G_idx].B = Bcolor;
    }
  }
}

 
void TFT_Extension::SetAll_RCB_Untoggled_Color( uint8_t Rcolor, uint8_t Gcolor, uint8_t Bcolor)
{
  for( uint8_t G_idx = 0; G_idx < TotalRCB_Group; G_idx++)
  {
    for(uint8_t temp = 0; temp < Block.number[G_idx]; temp++)
    {
      RCB_Untoggled_color[temp][G_idx].R = Rcolor;
      RCB_Untoggled_color[temp][G_idx].G = Gcolor;
      RCB_Untoggled_color[temp][G_idx].B = Bcolor;
    }
  }
}

//======================================================================
//
//======================================================================
void TFT_Extension::Triangle(int x1, int y1,int x2,int y2,int x3,int y3)
{
  _Disp->drawLine(x1,y1,x2,y2);// lean left
  _Disp->drawLine(x2,y2,x3,y3);// _ base
  _Disp->drawLine(x3,y3,x1,y1);// / lean right
}
 
void TFT_Extension::drawTriangle(int x1,int y1, int base, int deg)
{  
  int rad = base/2; int dir;

  if(deg < 90) dir=up;
  else if(deg < 180) dir=left; // down
  else if(deg < 270) dir=down;
  else dir = right;
  
  Cx = x1 + sin(float(deg) * deg_to_rad) * rad;
  Cy = y1 + cos(float(deg) * deg_to_rad) * rad;
  Cx1 = x1 + sin((float(deg) + 120) * deg_to_rad) * rad;
  Cy1 = y1 + cos((float(deg) + 120) * deg_to_rad) * rad;
  Cx2 = x1 + sin((float(deg) + 240) * deg_to_rad) * rad;
  Cy2 = y1 + cos((float(deg) + 240) * deg_to_rad) * rad;
  
  if(base >= 60)
  {
    switch(dir)
    {
     case up:
       Triangle(Cx,Cy,Cx1,Cy1,Cx2-1,Cy2-1);
       break;
	   
     case down:
	   Triangle(Cx+1,Cy,Cx1+1,Cy1,Cx2+1,Cy2+1);
       break;
	   
     case left:
	   Triangle(Cx,Cy,Cx1,Cy1,Cx2-1,Cy2+1);
       break;
	   
     case right:
	   Triangle(Cx,Cy,Cx1,Cy1,Cx2+1,Cy2);
       break;
    }
  }
  else 
    Triangle(Cx,Cy,Cx1,Cy1,Cx2,Cy2); 
}
 
void TFT_Extension ::fillTriangle(int x1,int y1,int base, int deg)
{   
  int rad = base/2; int dir;

  if(deg < 90) dir=up;
  else if(deg < 180) dir=left; 
  else if(deg < 270) dir=down;
  else dir = right;
  
  Cx = x1 + sin(float(deg) * deg_to_rad) * rad;
  Cy = y1 + cos(float(deg) * deg_to_rad) * rad;
  Cx1 = x1 + sin((float(deg) + 120) * deg_to_rad) * rad;
  Cy1 = y1 + cos((float(deg) + 120) * deg_to_rad) * rad;
  Cx2 = x1 + sin((float(deg) + 240) * deg_to_rad) * rad;
  Cy2 = y1 + cos((float(deg) + 240) * deg_to_rad) * rad;
  
  if(base >= 60)
  {
    switch(dir)
    {
     case up:
       Triangle(Cx,Cy,Cx1,Cy1,Cx2-1,Cy2-1);
       break;
	   
     case down:
	   Triangle(Cx+1,Cy,Cx1+1,Cy1,Cx2+1,Cy2+1);
       break;
	   
     case left:
	   Triangle(Cx,Cy,Cx1,Cy1,Cx2-1,Cy2+1);
       break;
	   
     case right:
	   Triangle(Cx,Cy,Cx1,Cy1,Cx2+1,Cy2);
       break;
    }
  }
  else 
    Triangle(Cx,Cy,Cx1,Cy1,Cx2,Cy2); 
  
  //having two does take longer, but this ensures that the triangle is completely filled.
  fillPoly(Cx,Cy,Cx1,Cy1,Cx2,Cy2); 
  fillPoly(Cx1,Cy1,Cx2,Cy2,Cx,Cy);
}

void TFT_Extension::Polygon(int cx, int cy, int sides, int diameter, byte R, byte G, byte B, bool fill, float deg)
{ 
  sides = (sides > 2? sides : 3); // This ensures the minimum side number is 3.
  int Xpoints[sides], Ypoints[sides];// Set the arrays based on the number of sides entered
  int rads = 360 / sides; // This equally spaces the points.
 
  for(int idx = 0; idx < sides; idx++) 
  { 
    Xpoints[idx] = cx + sin(float(idx*rads + deg) * deg_to_rad) * diameter; 
    Ypoints[idx] = cy + cos(float(idx*rads + deg) * deg_to_rad) * diameter;
  }
  
  _Disp->setColor(R,G,B);
  for(int idx = 0; idx < sides; idx++) // draws the polygon on the screen.
  {
    if( (idx+1) < sides) 
      _Disp->drawLine(Xpoints[idx],Ypoints[idx],Xpoints[idx+1],Ypoints[idx+1]); // draw the lines 
    else
      _Disp->drawLine(Xpoints[idx],Ypoints[idx],Xpoints[0],Ypoints[0]); // finishes the last line to close up the polygon.
  }
  if(fill)
    for(int idx = 0; idx < sides; idx++)
    {
      if((idx+1) < sides)
        fillPoly(cx,cy,Xpoints[idx],Ypoints[idx],Xpoints[idx+1],Ypoints[idx+1]);
      else
        fillPoly(cx,cy,Xpoints[idx],Ypoints[idx],Xpoints[0],Ypoints[0]);
    }
}

void TFT_Extension::fillPoly(int x1, int y1, int x2, int y2, int x3, int y3)
{      
  float xx = abs(x3-x2);
  float yy = abs(y3-y2)/xx;
  for(float i = 0; i < xx; i+=0.1)
  {
    _Disp->drawLine(x1,y1, x2 + (x2>x3 ? -i:i), y2 + ((yy*i) * (y2<y3 ? 1:-1) ));
  }
}

// Similar to the Polygon function.
void TFT_Extension::drawStar(int cx, int cy, int diameter, byte R, byte G, byte B, bool fill, float factor)
{
  factor = constrain(factor, 1.0, 4.0);
  uint8_t sides = 5;
  uint8_t rads = 360 / sides;
  
  int Xpoints_O[sides], Ypoints_O[sides], Xpoints_I[sides], Ypoints_I[sides];//Xpoints_T[sides], Ypoints_T[sides];

  for(int idx = 0; idx < sides; idx++)
  { 
    Xpoints_O[idx] = cx + sin(float(idx*rads + 72) * deg_to_rad) * diameter; // makes the outer points
    Ypoints_O[idx] = cy + cos(float(idx*rads + 72) * deg_to_rad) * diameter;
    Xpoints_I[idx] = cx + sin(float(idx*rads + 36) * deg_to_rad) * (float(diameter)/factor); // makes the inner points
    Ypoints_I[idx] = cy + cos(float(idx*rads + 36) * deg_to_rad) * (float(diameter)/factor); // 36 is half of 72, and this will allow the inner and outer points to line up like a triangle. 
  }
  
  _Disp->setColor(R,G,B);
  for(int idx = 0; idx < sides; idx++)
  {
    if((idx+1) < sides)
    { 
	  // this connects the outer points to the inner points and makes the lines
      _Disp->drawLine(Xpoints_O[idx],Ypoints_O[idx],Xpoints_I[idx+1],Ypoints_I[idx+1]);
      _Disp->drawLine(Xpoints_I[idx],Ypoints_I[idx],Xpoints_O[idx],Ypoints_O[idx]);
    }
    else
    {
      _Disp->drawLine(Xpoints_O[idx],Ypoints_O[idx],Xpoints_I[idx],Ypoints_I[idx]);
      _Disp->drawLine(Xpoints_I[0],Ypoints_I[0],Xpoints_O[idx],Ypoints_O[idx]);
    }
  }
  
  if(fill) // this part below should be self explanatory. It fills in the star.
    for(int idx = 0; idx < sides; idx++)
    {
      if((idx+1) < sides)
      {
        fillPoly(cx,cy,Xpoints_I[idx],Ypoints_I[idx],Xpoints_O[idx],Ypoints_O[idx]);
        fillPoly(cx,cy,Xpoints_O[idx],Ypoints_O[idx],Xpoints_I[idx+1],Ypoints_I[idx+1]);
      }
      else
      {
        fillPoly(cx,cy,Xpoints_I[0],Ypoints_I[0],Xpoints_O[idx],Ypoints_O[idx]); 
        fillPoly(cx,cy,Xpoints_O[idx],Ypoints_O[idx],Xpoints_I[idx],Ypoints_I[idx]);
      } 
    }
}

void TFT_Extension::drawArc(int cx, int cy, int radius, int thickness, int start, int stop, byte R, byte G, byte B)
{
  stop-=1;
  if(start > stop)
    swap(int, start, stop);
	
  int XI,YI,XR,YR,XL,YL;
  thickness = constrain(thickness, 0, radius);
  
  _Disp->setColor(R,G,B);
  for(int thick = (radius - thickness); thick <= radius; thick++)
  {
	for(float rotate = start; rotate <= stop; rotate+=0.5)
	{ 
	  XI = cx + sin((rotate - 90) * deg_to_rad) * float(thick);
	  YI = cy + cos((rotate - 90) * deg_to_rad) * float(thick);
	  if(rotate == start){ XR = XI; YR = YI;}
	  if(rotate == stop){XL = XI; YL = YI;}
	  _Disp->drawPixel(XI,YI);
	}
  }
  _Disp->drawLine(cx,cy, XR,YR); // draw the line for the bottom of the arc
  _Disp->drawLine(cx,cy, XL,YL); // =======================================
}

void TFT_Extension::drawOvalArc(int cx, int cy, int Xradius, int Yradius, int Xthickness, int Ythickness, int start, int stop, byte R, byte G, byte B)
{
  stop-=1;
  if(start > stop)
    swap(int, start, stop);
	
  int XI,YI,XR,YR,XL,YL;
  Xthickness = constrain(Xthickness, 0, Xradius);
  Ythickness = constrain(Ythickness, 0, Yradius);
  
  
  _Disp->setColor(R,G,B);
  for(float Xthick = (Xradius - Xthickness), Ythick = (Yradius - Ythickness)/Xradius; Xthick <= Xradius; Xthick++, Ythick+=0.1)
  {
	for(float rotate = start; rotate <= stop; rotate+=0.5)
	{ 
	  XI = cx + sin((rotate - 90) * deg_to_rad) * float(Xthick);
	  YI = cy + cos((rotate - 90) * deg_to_rad) * float(Ythick);
	  if(rotate == start){ XR = XI; YR = YI;}
	  if(rotate == stop){XL = XI; YL = YI;}
	  _Disp->drawPixel(XI,YI);
	}
  }
  _Disp->drawLine(cx,cy, XR,YR); // draw the line for the bottom of the arc
  _Disp->drawLine(cx,cy, XL,YL); // =======================================
}

void TFT_Extension::drawMoon(int cx, int cy, int radius, uint8_t phase)
{
  byte C = 0, N;
  int i=0;
  
  int Rad_D2 = radius/2;
  int Rad_D1_5 = radius/1.5;
  int Rad_M2 = radius*2;
  int Rad_M4 = radius*4;
  
  _Disp->setColor(240,240,240);
  _Disp->fillCircle(cx,cy,radius);
  for(N = 0; N < (Rad_D2); N++) // make craters when the moon is first made.
  {
    C = random(0, 20);
    _Disp->setColor(230 - C, 230 - C, 230 - C);
    _Disp->fillCircle(cx + random(-Rad_D1_5, Rad_D1_5), cy + random(-Rad_D1_5, Rad_D1_5), random(2, radius/7));
  }

  _Disp->setColor(100,100,100);
  _Disp->drawCircle(cx,cy, radius);
  
  int rad = map(phase, 0, 8, 0, Rad_M4);
  for(i = 0 ; i < rad; i++ ) // this draws the phase of the moon
  {
    if(i > Rad_M2) // change the fill color based on the phase
      _Disp->setColor(240,240,240);   
    else 
      _Disp->setColor(100,100,100);
      
    for(float rotate = 0 ; rotate <= 180 ; rotate+=1)
    {
      int XI = cx + sin(rotate * deg_to_rad) * float(radius - (i>(Rad_M2)? i-(Rad_M2):i));
      int YI = cy + cos(rotate * deg_to_rad) * float(radius);
      _Disp->drawPixel(XI,YI);
    }
  }
  //_Disp->printNumI(i, 0,0);
  if(i == 0 || i == Rad_M2) {} // disable craters if phase is FULL or NEW
  else if(i > Rad_M2)
  {
    for(N = 0; N < (Rad_D2); N++) // make craters after the moon has gotten to it's phase.
    {
      int tmp = random(-Rad_D1_5, map(i-5, Rad_M2, Rad_M4, -Rad_D1_5, Rad_D1_5)); // make craters based on the lighter area
      int tmp2 = random(-Rad_D1_5, Rad_D1_5); // confine the y-axis to the radius divided by 1.5.
      C = random(0, 20);
      _Disp->setColor(230 - C, 230 - C, 230 - C); //give each crater a random color from 230 to 250
      _Disp->fillCircle(cx + tmp, cy + tmp2, random(2, radius/7));
    }
  }
}

void TFT_Extension::rounded_Square(int cx,int cy,int h, int w, float radius, byte R, byte G, byte B, bool fill)
{ 
  uint8_t angle;
  float i;

  int newW = (w/2) - (radius/2); // space the arcs based on the entered width but keep within the overall width and radius
  int newH = (h/2) - (radius/2); // space the arcs based on the entered height but keep within the overall height and radius

  // these arrays are to keep track of where each arc starts and ends then to use this data to draw or fill the rest in.
  int XPstart[4], XPend[4]; 
  int YPstart[4], YPend[4];

  _Disp->setColor(R, G, B);

  for(angle = 0; angle < 4; angle++)
  {
    XPstart[angle] = ((angle <= 1)? cx - newW : cx + newW) + sin(90*angle * deg_to_rad) * (radius/2);
    YPstart[angle] = ((angle == 0 || angle == 3) ? cy - newH : cy + newH) + cos(90*angle * deg_to_rad) * (radius/2);
    for(i = 90*angle; i <= 90*(angle+1); i++)
    { 
      XPend[angle] = ((angle <= 1)? cx - newW : cx + newW) + (sin(i * deg_to_rad) * (radius/2));
      YPend[angle] = ((angle == 0 || angle == 3) ? cy - newH : cy + newH) + (cos(i * deg_to_rad) * (radius/2));

      if(!fill) // no fill
        _Disp->drawPixel(XPend[angle], YPend[angle]); 
    }
    if(fill) //fill
      drawArc(
       ((angle <= 1)? cx - newW : cx + newW), // Xcoords
       ((angle == 0 || angle == 3) ? cy - newH : cy + newH), //Ycoords
       radius/2, // radius of arc
	   radius/2, // must match arc radius
       90*angle + 90, // start angle + 90* to correctly position the Arc
       i + 90, // end angle + 90*
       R, G, B // color
      );
  }
  
  _Disp->setColor(R,G,B); 
  if(fill) // fill in the area between the outer lines
  {
    _Disp->fillRect(XPend[0], YPend[0], XPend[2], YPend[2]); //fill horizontally
    _Disp->fillRect(XPstart[0], YPstart[0], XPstart[2], YPstart[2]+1); // fill vertically
  }
  else
  {
    for(angle=0; angle <= 3; angle++)// draw the outer lines
    {
      _Disp->drawLine(XPend[angle], YPend[angle], XPstart[angle+1 == 4? 0 : angle+1], YPstart[angle+1 == 4? 0 : angle+1]);
    }
  }
}

void TFT_Extension::smiley_Face(int cx, int cy, int radius, byte eyes, byte mouth)
{
  int XI,YI,XI2;
  _Disp->setColor(YELLOW);
  _Disp->fillCircle(cx,cy,radius);
  _Disp->setColor(BLACK);
  _Disp->drawCircle(cx,cy,radius);

  switch(eyes)
  {
  case 0:// normal eyes
    for(float rotate = 0 ; rotate <= 360 ; rotate+=1) 
    {
      XI = (cx - radius/3) + sin((rotate - 90) * deg_to_rad) * (radius/10);
      YI = (cy - radius/3) + cos((rotate - 90) * deg_to_rad) * (radius/3.3);
      XI2 = (cx + radius/3) + sin((rotate - 90) * deg_to_rad) * (radius/10);
      _Disp->drawLine(cx - radius/3,cy - radius/3,XI,YI);
      _Disp->drawLine(cx + radius/3,cy - radius/3,XI2,YI);
    }
    break;

  case 1: // round eyes
    _Disp->fillCircle(cx - radius/3, cy - radius/3, radius/8);
    _Disp->fillCircle(cx + radius/3, cy - radius/3, radius/8);
    break;

  case 2: // over joyed
    drawArc(cx - radius/3, cy - radius/3, radius/5, radius/25, 0, 180, BLACK); 
    drawArc(cx + radius/3, cy - radius/3, radius/5, radius/25, 0, 180, BLACK);
    break;

  case 3: // content
    drawArc(cx - (radius/3), cy - (radius/3), radius/5, radius/25, 180, 360, BLACK);
    drawArc(cx + (radius/3), cy - (radius/3), radius/5, radius/25, 180, 360, BLACK);
    break;

  case 4: // angry
    for(byte i = 0; i < 2; i++)
    {
      _Disp->drawLine((cx - radius/5) - i, cy - radius/5, (cx - radius/2) - i, cy - radius/2);
      _Disp->drawLine((cx + radius/5) - i, cy - radius/5, (cx + radius/2) - i, cy - radius/2);
    }
    break;

  case 5://very angry
    for(byte i = 0; i < 2; i++)
    {
      _Disp->drawLine((cx - radius/5) - i, cy - radius/5, (cx - radius/2) - i, cy - radius/2);
      _Disp->drawLine((cx + radius/5) - i, cy - radius/5, (cx + radius/2) - i, cy - radius/2);
      drawArc(cx - radius/3, cy - radius/3, radius/6, 135, 305, i, BLACK);
      drawArc(cx + radius/3, cy - radius/3, radius/6, 240, 395, i, BLACK);
    }
    break;

  case 6: // big eyes
    drawArc(cx - radius/3, cy - radius/3, radius/6, radius/25, 0, 360, BLACK);
    drawArc(cx + radius/3, cy - radius/3, radius/6, radius/25, 0, 360, BLACK);
    break;

  case 7:
    _Disp->setColor(WHITE);
    _Disp->fillCircle(cx - radius/4, cy - radius/3, radius/5);
    _Disp->fillCircle(cx + radius/4, cy - radius/3, radius/5);
    _Disp->setColor(BLACK);
    _Disp->drawCircle(cx - radius/4, cy - radius/3, radius/5);
    _Disp->drawCircle(cx + radius/4, cy - radius/3, radius/5);
    _Disp->drawPixel(cx - radius/4, cy - radius/3);
    _Disp->drawPixel(cx + radius/4, cy - radius/3);
    break;

  case 8:
    _Disp->drawLine(cx - radius/3, cy - radius/1.5, cx, cy - radius/2.5);
    _Disp->drawLine(cx - radius/3, cy - radius/3.5, cx, cy - radius/2.5);
    _Disp->drawLine(cx + radius/3, cy - radius/1.5, cx, cy - radius/2.5);
    _Disp->drawLine(cx + radius/3, cy - radius/3.5, cx, cy - radius/2.5);
    break;

  case 9:
    drawArc(cx - radius/3, cy - radius/3, radius/5, radius/5, 180, 361, BLACK);
    drawArc(cx + radius/3, cy - radius/3, radius/5, radius/5, 180, 361, BLACK); 
    break;
  }

  switch(mouth)
  {
  case 0:
    drawArc(cx,cy, int(float(radius)/1.6), radius/25, 180, 360, BLACK); // big happy smile
    break;

  case 1:
    drawArc(cx,cy, int(float(radius)/1.6), radius/25, 210, 330, BLACK); // happy smile
    break;

  case 2:
    drawArc(cx,cy + radius/1.5 , radius/2, radius/25, 30, 150, BLACK); // frown
    break;

  case 3: // big open smile
    drawArc(cx,cy, int(float(radius)/1.6), int(float(radius)/1.6), 181, 360, WHITE);
    for(byte i = 0; i <= radius/25; i++)
    {
      drawArc(cx,cy, int(float(radius)/1.6), i, 181, 360, BLACK);
      _Disp->drawLine(cx - radius/1.8, cy+i, cx + radius/1.8, cy+i);
    }
    break;

  case 4:
    drawArc(cx,cy + radius , radius/2, radius/25, 60, 120, BLACK); //big frown
    break;

  case 5:
    drawArc(cx,cy + radius/1.5 , radius/2, radius/25, 0, 180, BLACK); // bigger frown
    break;

  case 6:
    drawArc(cx,cy + radius/1.5 , radius/2, radius/3, 70, 110, BLACK); // shocked open mouth
    break;

  case 7:
    drawArc(cx,cy + radius , radius/1.2, radius/3, 50, 130, BLACK); // crying mouth
    break;
  }
}

void TFT_Extension::HourGlass(int cx, int cy, int height, int time)
{
  _Disp->setColor(BLACK);
  if(!locked)
  {
    rad = height;
    locked = true;
  }

  if(rad >= 0)
  {
    int Cx  = cx + sin(135 * deg_to_rad) * rad; 
    int Cy  = cy + cos(135 * deg_to_rad) * rad;
    int Cx2 = cx + sin(225 * deg_to_rad) * rad; 
    int Cy2 = cy + cos(225 * deg_to_rad) * rad;
    int Cx3 = cx + sin(315 * deg_to_rad) * rad; 
    int Cy3 = cy + cos(315 * deg_to_rad) * rad;
    int Cx4 = cx + sin(45 * deg_to_rad) * rad; 
    int Cy4 = cy + cos(45 * deg_to_rad) * rad;
	
	if(flip)
	{
	  if(millis() - T > float((time*1000UL) / float(height)))
      {
        T = millis(); 
       rad--;
      }
      _Disp->setColor(LIGHT_ORANGE);
      _Disp->drawLine(Cx+2 , Cy, Cx2-2, Cy2);// bottom 
      _Disp->drawLine(cx-1,cy, cx-1,Cy);
      _Disp->setColor(BLACK);
      _Disp->drawLine(Cx3-2, Cy3, Cx4+2, Cy4); // top
	}
    else
	{
      rad--;
      _Disp->setColor(BLACK);
      _Disp->drawLine(Cx , Cy, Cx2, Cy2);// bottom 
      _Disp->drawLine(Cx2, Cy2, Cx4, Cy4);// left
      _Disp->drawLine(Cx3, Cy3, Cx, Cy); // right
      _Disp->setColor(LIGHT_ORANGE);
      _Disp->drawLine(Cx3, Cy3, Cx4, Cy4); // top
    }
  }
  else 
  {
    flip = !flip;
    rad = height;
    T = millis(); 
  }
}

void TFT_Extension::SpeechBubble(char * str, int cx, int cy, float radius, int deg)
{
  float start, stop;
  int x,y,xo,yo,fx,fy;
  int Lx1,Ly1,Lx2,Ly2;
  byte strl = strlen(str);
  byte MidTxt = int((radius*2) - (radius/2))/8;
  
  //_Disp->printNumI(strl, 0,0);
  //_Disp->printNumI(MidTxt ,0,10);
   //  byte Ytxtlen = (radius / 16);
  //  int CX_Offset[Ytxtlen];
  //  byte OuterTxt = (radius/8);
  //  int txtTotal = (MidTxt * (Ytxtlen/2)) + (OuterTxt*2);

  //  for(byte i = 0; i < Ytxtlen; i++)
  //  {
  //   if(i == 0 || i == (Ytxtlen-1) )
  //     CX_Offset[i] = OuterTxt;
  //   else 
  //     CX_Offset[i] = MidTxt;
  //  }

  //_Disp->printNumI(txtTotal, 0,0);

  if(deg < 180)
  {
    start = deg + 15;
    stop = (deg - 15 > 0? (360 + (deg - 15)) : (360 - (deg + 15)));
  }
  else 
  {
    start = deg - 360 + 15;
    stop = deg-15;
  }

  Lx1 = cx + sin((start - 90) * deg_to_rad) * radius;
  Ly1 = cy + cos((start - 90) * deg_to_rad) * (radius/2);
  Lx2 = cx + sin((stop - 90) * deg_to_rad) * radius;
  Ly2 = cy + cos((stop - 90) * deg_to_rad) * (radius/2);

  for (float i = start; i < stop; i += 1) 
  {
    x = cx + sin((i - 90) * deg_to_rad) * radius;
    y = cy + cos((i - 90) * deg_to_rad) * (radius/2);
    xo = cx + sin((deg - 90) * deg_to_rad) * (radius*1.5);
    yo = cy + cos((deg - 90) * deg_to_rad) * (radius);
    _Disp->setColor(0,0,0);
    _Disp->drawPixel(x, y);
  } 
  _Disp->setColor(WHITE); 
  for(byte f= 1; f < radius*2; f++)
  {
    for(float i = 0; i < 180; i+= 1)
    {
      fx = cx + sin(i * deg_to_rad) * (radius-f);
      fy = cy + cos(i * deg_to_rad) * ((radius/2)-1);
      _Disp->drawPixel(fx,fy);
    }
  }
  fillPoly(xo,yo, Lx2, Ly2,Lx1, Ly1);
  _Disp->setColor(BLACK);
  _Disp->drawLine(xo,yo, Lx1, Ly1);
  _Disp->drawLine(xo,yo, Lx2, Ly2);
  _Disp->setBackColor(WHITE);

  _Disp->setFont(SmallFont);
  //  byte i = 0;
  //  if(strl > int(txtTotal))
  //    _Disp->print("ERR", cx - (3*4), cy - 6, 0);
  //  else
  //  {
  //    byte S = 0, CY = 0, CX = 0;
  //    for(int s = -(strl/2); s < (strl/2); s++, S++)
  //    {
  //            _Disp->printNumI( strl, 0,20);
  //            //_Disp->printNumI(txtTotal, 0,30);
  //      //      _Disp->printNumI(CX_Offset, 0,40);
  //
  //      if(strl > ((radius*2)/8) )
  //      {
  //        delay(1000);
  //        _Disp->printNumI(CX_Offset[i], 0,30);
  //        _Disp->printNumI(S % CX_Offset[i], 0,40);
  //        if((S % CX_Offset[i]) == (CX_Offset[i] - 1)) i++;
  //        CY = map((S / CX_Offset[i]), 0, Ytxtlen,  -(Ytxtlen * 16), (Ytxtlen * 16) );
  //        CX = map(S % CX_Offset[i], 0, CX_Offset[i], -CX_Offset[i]/2, CX_Offset[i]/2 );
  //        _Disp->printChar(str[S], cx + (CX * 8), cy + CY ); // small font is 8x12
  //      }
  //      else 
  if(strl <= MidTxt)
    _Disp->print(str, cx - (strl*4), cy - 6, 0);
  else 
    _Disp->print("TTL", cx - (3*4), cy - 6, 0); // TTL = Text Too Long
  //}
//}
}

void TFT_Extension::drawGauge(int cur, int pos_x, int pos_y, int start, int stop, int rad)
{
  _Disp->setColor(WHITE);
  if(!locked)
  {
   drawArc(pos_x, pos_y, rad, rad, start, stop, WHITE);
   drawArc(pos_x, pos_y, rad, 0, start, stop, BLACK);
   oldx = pos_x; 
   oldy = pos_y;
   locked = true;
  }
  x = pos_x + sin((cur-90) * deg_to_rad) * (rad-2);
  y = pos_y + cos((cur-90) * deg_to_rad) * (rad-2);

  if(x != oldx && y != oldy)
  {
    _Disp->setColor(WHITE);
    _Disp->drawLine(oldx, oldy, pos_x, pos_y);  
    _Disp->setColor(BLACK);
    _Disp->drawLine(x, y,pos_x,pos_y); // (cx, cy, calculated x, calculated y)
    oldx = x; 
    oldy = y;
    //_Disp->printNumF(cur,2,CENTER,10);//used for debugging  
  }
  _Disp->setColor(WHITE);	
}
//================END_OF_DISPLAY_FUNCTIONS=======================