#include <UTFT.h>
#include <UTouch.h>
#include <TFT_Extension.h>
// Declare which fonts we will be using
extern uint8_t SmallFont[];

//myGLCD(RS,WR,CS,RST,ALE,mode);
UTFT myGLCD(ITDB32S,A1,A2,A0,A3,A5);
//myTouch(TCLK,TCS,DIN,DOUT,IRQ);
UTouch  myTouch(13,10,11,12,A4);
TFT_Extension myTFT(&myGLCD, &myTouch, LANDSCAPE);

void setup()
{
  myGLCD.InitLCD(LANDSCAPE);
  myGLCD.clrScr();
  myGLCD.setFont(SmallFont);
  myTouch.InitTouch(LANDSCAPE);
  myTouch.setPrecision(PREC_LOW);
  myGLCD.fillScr(WHITE);
}

void loop()
{ 
  //(X1, Y1, X2, Y2, ID Number, Color) 
  byte red = map(myTFT.HorSlider(20, 20, 210, 50, 0, RED), 0, 100, 0, 255);
  byte green = map(myTFT.HorSlider(20, 70, 210,100, 1, GREEN), 0, 100, 0, 255);
  byte blue = map(myTFT.HorSlider(20, 120, 210,150, 2, BLUE), 0, 100, 0, 255);
  
  myGLCD.setColor(WHITE);
  myGLCD.printNumI(red, 20, 9);
  myGLCD.printNumI(green, 20, 59);
  myGLCD.printNumI(blue, 20, 109);
  
  myGLCD.setColor(red, green, blue);
  myGLCD.fillRect(230, 10, 280, 60);
}










